/* Copyright 1991 Digital Equipment Corporation.               */
/* All rights reserved. See copyright notice in attached file COPYRIGHT. */
/* Last modified on Mon Aug 19 22:33:13 1991 by burrows        */
#include <stdio.h>
#include <errno.h>

extern void exit ();
extern void perror ();
extern char *realloc ();
extern long atol ();
extern long strtol ();
extern void bcopy ();

struct msg {
	long date;
	long msg;
};

static int compar (a, b)
register struct msg *a, *b;
{
	register int cmp = a->date - b->date;

	if (cmp != 0)
		return (cmp);
	return (a->msg-b->msg);
}

#define READSIZE	8192
#define MIN(a,b)	((a)<(b)?(a):(b))

/* ARGSUSED */
main (argc, argv)
int argc;
char *argv[];
{
	register char *p, *e;
	register int c;
	register struct msg *msgs = 0;
	register long nmsgs = 0;
	long maxmsgs = 0;
	char buf[READSIZE+512];
	register long i;
	int got = 0;
	int nread;

	while ((nread = read (0, buf+got, MIN(sizeof(buf)-got,READSIZE))) > 0) {
		got += nread;
		p = buf;
		e = buf + got;
		while (e > p && e[-1] != '\n')
			e--;
		
		while (p < e) {
			if (nmsgs >= maxmsgs) {
				maxmsgs += 1024+(maxmsgs >> 1);
				msgs = (struct msg *) realloc ((char *) msgs,
				    (unsigned) maxmsgs * sizeof (struct msg));
				if (msgs == 0) {
					perror ("mkdate: realloc");
					exit (2);
				}
			}
			msgs[nmsgs].msg = atol (p);
			c = 1;
			for (i = 0; i < 5 && c != 0; i++) {
				while ((c = *p++) != '\t' && c != '\n' &&
				       (c = *p++) != '\t' && c != '\n' &&
				       (c = *p++) != '\t' && c != '\n' &&
				       (c = *p++) != '\t' && c != '\n')
					;
			}
			if (c != 0) {
				msgs[nmsgs].date =
					strtol (p, (char **) 0, 16);
			} else {
				msgs[nmsgs].date = 0;
				p--;
			}
			nmsgs++;
			while (*p++ != '\n' && *p++ != '\n' &&
			       *p++ != '\n' && *p++ != '\n')
				;
		}
		got -= p - buf;
		if (got > 0)
			bcopy (p, buf, got);
	}

	if (ferror (stdin)) {
		perror ("mkdate: stdin");
		exit (2);
	}

	qsort ((char *) msgs, (int) nmsgs, sizeof (struct msg), compar);

	for (i = 0; i < nmsgs; i++) {
		(void) fwrite ((char *) &msgs[i].msg, sizeof (long), 1, stdout);
	}

	(void) fflush (stdout);
	if (ferror (stdout) || fsync (fileno (stdout)) < 0 && errno != EINVAL) {
		perror ("mkdate: stdout");
		exit (2);
	}
	exit (0);
}
